<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  	<title>Doozer - Example</title>
  	<style>
      BODY { font-family: "Segoe UI", "Gill Sans", Optima, Helvetica, Tahoma, Arial, Sans-Serif; font-size: 15px; padding: 20px 100px; }
  	  P, TD, LI, PRE, CODE { color: gray; }
  	  PRE { background-color: #F0F0F0; padding: 15px; }
  	  #header * { margin: 0; padding: 0; }
  	  #header h1 { color: navy; }
  	  #navigation { margin-top: 15px; background: #E0E0E0; padding: 5px 15px; font-weight: bolder; text-align: center; }
  	  #navigation A, #navigation SPAN { margin-right: 20px; text-shadow: 3px 3px 4px #999; }
  	  #navigation A { color: black; }
  	  #navigation A:hover { color: navy; }
  	  #navigation SPAN { color: white; }
  	  #content A { color: navy; }
  	  #content A:hover { color: blue; }
  	  #footer { margin: 15px 0px; }
  	  #footer A { color: gray; }
  	  #footer #info { color: gray; float:right; }
  	</style>
  </head>
  <body>
    <div id="container">
      <div id="header">
        <h1>Doozer</h1>
        <h4>Simple Fixture Generator</h4>
      </div>
      <div id="navigation">
        
          
            <span>Example</span>
          
        
          
            <a href="fixture-comparison.html">Fixture Comparison</a>
          
        
          
            <a href="index.html">Index</a>
          
        
          
            <a href="test-specs.html">Test Specs</a>
          
        
      </div>
      <div id="content">
        <p>If <code>Node</code> is an <code>ActiveRecord</code> class that implements <code>acts_as_tree</code>, then fixtures would usually look like:</p>

<pre><code>root:
  id: 1
  parent_id:
  name: Root Node

child_1:
  id: 2
  parent_id: 1
  name: First Child

child_1_1:
  id: 3
  parent_id: 2
  name: Sub Child 1

child_1_2:
  id: 4
  parent_id: 2
  name: Sub Child 2

child_2:
  id: 5
  parent_id: 1
  name: Second Child
</code></pre>

<p>This gets really hard to read, and to manage with all the juggling of those ID's. Plus it's difficult, at a glace, to get a good idea of the data's structure. With Doozer, you can get a much better visualization of this kind of fixture data, and not have to manage as much tedium:</p>

<pre><code>Doozer.define :node do
  field_order   :name
  block_affects :child=&gt;:parent_id
end

node "Root Node" do
  node "First Child" do
    node "Sub Child 1"
    node "Sub Child 2"
  end
  node "Second Child"
end
</code></pre>

<p>This Doozer script generates the following YAML:</p>

<pre><code>node_1:
  id: 1
  parent_id:
  name: Root Node

node_2:
  id: 2
  parent_id: 1
  name: First Child

node_3:
  id: 3
  parent_id: 2
  name: Sub Child 1

node_4:
  id: 4
  parent_id: 2
  name: Sub Child 2

node_5:
  id: 5
  parent_id: 1
  name: Second Child
</code></pre>

<p>You'll notice that the names are now generated; <code>node_1</code> instead of <code>root</code>. We can specify fixture names too. If the first argument to the <code>node()</code> macro (that <code>Doozer.define(sym)</code> generates) is a <code>Symbol</code>, then it's used as the fixture's name. So, our updated Doozer fixture looks like this:</p>

<pre><code>node :root, "Root Node" do
  node :child_1, "First Child" do
    node :child_1_1, "Sub Child 1"
    node :child_1_2, "Sub Child 2"
  end
  node :child_2, "Second Child"
end
</code></pre>

<p>Now the generated fixture will be the same as our original listing.</p>

<p>You can reference a named fixture multiple times in the same Doozer script. Each time it will collect the information sent and merge it with previous calls. So, for example, let's say we just want to show the node structure first, and then fill out the node names in a more tabular fashion. Our Doozer fixture changes to this:</p>

<pre><code>node :root do
  node :child_1  do
    node :child_1_1
    node :child_1_2
  end
  node :child_2
end

node :root,      "Root Node"
node :child_1,   "First Child"
node :child_1_1, "Sub Child 1"
node :child_1_2, "Sub Child 2"
node :child_2,   "Second Child"
</code></pre>

<p>This generates the same fixture as before, only now the structure really shows through. </p>

<p>Now let's say I've added a <code>created_on</code> field to the <code>Node</code> class. I don't really wanna go through every node in the fixture and add that info, I'd rather specify a default value for it. Doozer makes this quite easy, you just add the <code>defaults</code> to the definition block, like so:</p>

<pre><code>Doozer.define :node do
  field_order   :name
  block_affects :child=&gt;:parent_id
  defaults      :created_on=&gt;Time.now.to_s(:db)
end
</code></pre>

<p>And now, all of your generated fixtures will have <code>created_on</code> fields with the value returned from <code>Time.now.to_s(:db)</code>.</p>
      </div>
      <div id="footer">
        <div id="info">
          Created by <a href="http://www.mattmccray.com">M@ McCray</a>
        </div>
        <a href="#">^ back to the top</a>
      </div>
    </div>
  </body>
</html>


